<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Terminy\Listeners\Udalost;

use App\Models\Pouzivatel\Pouzivatel;
use App\Models\Pracovisko\Pracovisko;
use Illuminate\Support\Facades\Notification;
use Seka\Portal\Modul\Terminy\Entities\Dtos\UdalostDTO;
use Seka\Portal\Modul\Terminy\Events\Udalost\NovaZverejnenaUdalost;
use Seka\Portal\Modul\Terminy\Notifications\Udalost\ZverejnenaNovaUdalostNotifikaciaDB;
use Seka\Portal\Modul\Terminy\Notifications\Udalost\ZverejnenaNovaUdalostNotifikaciaMail;

/**
 * Class ZverejnitNovuUdalostNotifikacia
 *
 * @package Seka\Portal\Modul\Terminy\Listeners\Udalost
 */
final class ZverejnitNovuUdalostNotifikacia
{
    /**
     * @param \Seka\Portal\Modul\Terminy\Events\Udalost\NovaZverejnenaUdalost $event
     *
     * @throws \Illuminate\Contracts\Container\BindingResolutionException
     * @throws \Spatie\LaravelData\Exceptions\CannotCreateData
     */
    public function handle(NovaZverejnenaUdalost $event): void
    {
        if ($event->udalost->nieJePovoleneUpozornenie()) {
            return;
        }

        $udalost = UdalostDTO::from($event->udalost);

        Notification::send(
            Pouzivatel::query()->aktivny()->get(),
            new ZverejnenaNovaUdalostNotifikaciaDB($udalost),
        );

        Notification::send(
            collect(
                Pracovisko::query()->get(),
            )->merge(
                Pouzivatel::query()->where('email', '!=', null)->aktivny()->get(),
            ),
            new ZverejnenaNovaUdalostNotifikaciaMail($udalost),
        );
    }
}
